"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_bootstrap_button_with_spinner_1 = tslib_1.__importDefault(require("@vlsergey/react-bootstrap-button-with-spinner"));
var react_1 = tslib_1.__importStar(require("react"));
var Alert_1 = tslib_1.__importDefault(require("react-bootstrap/Alert"));
var Col_1 = tslib_1.__importDefault(require("react-bootstrap/Col"));
var Modal_1 = tslib_1.__importDefault(require("react-bootstrap/Modal"));
var ProgressBar_1 = tslib_1.__importDefault(require("react-bootstrap/ProgressBar"));
var Row_1 = tslib_1.__importDefault(require("react-bootstrap/Row"));
var DefaultUserOptions_1 = tslib_1.__importDefault(require("./DefaultUserOptions"));
var generateCsv_1 = tslib_1.__importDefault(require("./generateCsv"));
var UserOptionsFormPart_1 = tslib_1.__importDefault(require("./UserOptionsFormPart"));
function ExportToCsvModal(_a) {
    var _this = this;
    var fileName = _a.fileName, fields = _a.fields, fetchPage = _a.fetchPage, _b = _a.idPrefix, idPrefix = _b === void 0 ? 'csvExport' : _b, _c = _a.modalHeader, modalHeader = _c === void 0 ? 'Export to CSV' : _c, onHide = _a.onHide, show = _a.show;
    var _d = tslib_1.__read(react_1.useState(DefaultUserOptions_1.default), 2), userOptions = _d[0], setUserOptions = _d[1];
    var _e = tslib_1.__read(react_1.useState(false), 2), retry = _e[0], setRetry = _e[1];
    var _f = tslib_1.__read(react_1.useState(null), 2), error = _f[0], setError = _f[1];
    var _g = tslib_1.__read(react_1.useState(false), 2), inProgress = _g[0], setInProgress = _g[1];
    var _h = tslib_1.__read(react_1.useState(0), 2), progress = _h[0], setProgress = _h[1];
    var _j = tslib_1.__read(react_1.useState(100), 2), progressMax = _j[0], setProgressMax = _j[1];
    var doGenerate = react_1.useCallback(function () { return tslib_1.__awaiter(_this, void 0, void 0, function () {
        var err_1;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    setError(null);
                    setInProgress(true);
                    setProgress(0);
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, 4, 5]);
                    return [4 /*yield*/, generateCsv_1.default(tslib_1.__assign(tslib_1.__assign({}, userOptions), { fileName: fileName, fields: fields, fetchPage: fetchPage }), function (progress, progressMax) {
                            setProgress(progress);
                            setProgressMax(progressMax);
                        })];
                case 2:
                    _a.sent();
                    return [3 /*break*/, 5];
                case 3:
                    err_1 = _a.sent();
                    console.warn('Unable to export to CSV: ');
                    console.warn(err_1);
                    setError(err_1);
                    return [3 /*break*/, 5];
                case 4:
                    setInProgress(false);
                    setRetry(true);
                    return [7 /*endfinally*/];
                case 5: return [2 /*return*/];
            }
        });
    }); }, [fetchPage, fields, fileName, setProgress, setProgressMax, userOptions]);
    return react_1.default.createElement(Modal_1.default, { onHide: onHide, show: show },
        react_1.default.createElement(Modal_1.default.Header, { closeButton: true }, modalHeader),
        react_1.default.createElement(Modal_1.default.Body, null,
            react_1.default.createElement(Row_1.default, null,
                react_1.default.createElement(Col_1.default, null,
                    react_1.default.createElement(UserOptionsFormPart_1.default, { disabled: inProgress, idPrefix: idPrefix + 'Options', onChange: setUserOptions, value: userOptions }))),
            error && react_1.default.createElement(Row_1.default, null,
                react_1.default.createElement(Col_1.default, null,
                    react_1.default.createElement(Alert_1.default, { variant: "danger" },
                        'Error occured on CSV export: ',
                        error.message || JSON.stringify(error)))),
            !inProgress && !error && progress == progressMax && react_1.default.createElement(Row_1.default, null,
                react_1.default.createElement(Col_1.default, null,
                    react_1.default.createElement(Alert_1.default, { variant: "info" }, 'CSV export completed'))),
            react_1.default.createElement(Row_1.default, null,
                react_1.default.createElement(Col_1.default, null,
                    react_1.default.createElement("div", { style: { marginBottom: 12 } },
                        react_1.default.createElement(ProgressBar_1.default, { animated: inProgress, max: progressMax, now: progress }))))),
        react_1.default.createElement(Modal_1.default.Footer, null,
            react_1.default.createElement(react_bootstrap_button_with_spinner_1.default, { disabled: inProgress, onClick: doGenerate, variant: "primary" }, retry ? 'Retry export to CSV' : 'Export to CSV'),
            react_1.default.createElement(react_bootstrap_button_with_spinner_1.default, { onClick: onHide, variant: "secondary" }, "Close")));
}
exports.default = react_1.default.memo(ExportToCsvModal);
