"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importStar(require("react"));
var Form_1 = tslib_1.__importDefault(require("react-bootstrap/Form"));
var html_value_to_value = {
    n: '\n',
    r: '\r',
    rn: '\r\n',
    t: '\t',
};
var value_to_html_value = {
    '\n': 'n',
    '\r': 'r',
    '\r\n': 'rn',
    '\t': 't',
};
function UserOptionsFormPart(_a) {
    var _b = _a.disabled, disabled = _b === void 0 ? false : _b, _c = _a.idPrefix, idPrefix = _c === void 0 ? '' : _c, onChange = _a.onChange, value = _a.value;
    var handleChange = react_1.useCallback(function (_a) {
        var _b;
        var currentTarget = _a.currentTarget;
        onChange(tslib_1.__assign(tslib_1.__assign({}, value), (_b = {}, _b[currentTarget.name] = html_value_to_value[currentTarget.value] || currentTarget.value, _b)));
    }, [onChange, value]);
    var handleTrigger = react_1.useCallback(function (_a) {
        var _b;
        var _c = _a.currentTarget, name = _c.name, checked = _c.checked;
        var fieldName = name;
        onChange(tslib_1.__assign(tslib_1.__assign({}, value), (_b = {}, _b[fieldName] = checked, _b)));
    }, [onChange, value]);
    return react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(Form_1.default.Group, null,
            react_1.default.createElement(Form_1.default.Check, { checked: value.header, disabled: disabled, id: idPrefix + "header", label: "Include header line (with column names) to CSV", name: "header", onChange: handleTrigger })),
        react_1.default.createElement(Form_1.default.Group, null,
            react_1.default.createElement(Form_1.default.Label, null, "Values separator"),
            react_1.default.createElement(Form_1.default.Control, { as: "select", disabled: disabled, id: idPrefix + "separator", name: "separator", onChange: handleChange, value: value_to_html_value[value.separator] || value.separator },
                react_1.default.createElement("option", { value: "," }, "Colon \u201C,\u201D"),
                react_1.default.createElement("option", { value: "t" }, "Tab \u201C\\t\u201D"),
                react_1.default.createElement("option", { value: ";" }, "Semicolon \u201C;\u201D"))),
        react_1.default.createElement(Form_1.default.Group, null,
            react_1.default.createElement(Form_1.default.Label, null, "Line break character"),
            react_1.default.createElement(Form_1.default.Control, { as: "select", disabled: disabled, id: idPrefix + "newline", name: "newline", onChange: handleChange, value: value_to_html_value[value.newline] || value.newline },
                react_1.default.createElement("option", { value: 'rn' }, "Windows-style \u201C\\r\\n\u201D"),
                react_1.default.createElement("option", { value: 'n' }, "*nix-style \u201C\\n\u201D"),
                react_1.default.createElement("option", { value: 'r' }, "Mac-style \u201C\\r\u201D"))));
}
exports.default = react_1.default.memo(UserOptionsFormPart);
