"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var csvEscape_1 = tslib_1.__importDefault(require("./csvEscape"));
function generateContent(options, onContent) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var getters, lastPage, pageNumber, totalLines, page, items, lines, lines_1, lines_1_1, line, e_1_1;
        var e_1, _a;
        return tslib_1.__generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    getters = [];
                    options.fields.forEach(function (field) {
                        var getter = field.getter, key = field.key, toPlain = field.toPlain;
                        var actualGetter = getter || (function (item) { return item[key]; });
                        var actualToPlain = toPlain || (function (value) {
                            if (value === null || value === undefined) {
                                return null;
                            }
                            var t = typeof value;
                            switch (t) {
                                case 'string':
                                case 'number':
                                    return value;
                                case 'undefined':
                                    return null;
                                default:
                                    return JSON.stringify(value);
                            }
                        });
                        var resultGetter = function (item) { return actualToPlain(actualGetter(item), item); };
                        getters.push(resultGetter);
                    });
                    lastPage = false;
                    pageNumber = -1;
                    totalLines = 0;
                    _b.label = 1;
                case 1:
                    pageNumber++;
                    return [4 /*yield*/, options.fetchPage(pageNumber)];
                case 2:
                    page = _b.sent();
                    lastPage = page.number >= page.totalPages;
                    items = page.content;
                    lines = items.map(function (item) {
                        return getters.map(function (getter) { return getter(item); }).map(csvEscape_1.default).join(options.separator);
                    });
                    _b.label = 3;
                case 3:
                    _b.trys.push([3, 8, 9, 10]);
                    lines_1 = (e_1 = void 0, tslib_1.__values(lines)), lines_1_1 = lines_1.next();
                    _b.label = 4;
                case 4:
                    if (!!lines_1_1.done) return [3 /*break*/, 7];
                    line = lines_1_1.value;
                    return [4 /*yield*/, onContent(page.totalElements, line + options.newline)];
                case 5:
                    _b.sent();
                    _b.label = 6;
                case 6:
                    lines_1_1 = lines_1.next();
                    return [3 /*break*/, 4];
                case 7: return [3 /*break*/, 10];
                case 8:
                    e_1_1 = _b.sent();
                    e_1 = { error: e_1_1 };
                    return [3 /*break*/, 10];
                case 9:
                    try {
                        if (lines_1_1 && !lines_1_1.done && (_a = lines_1.return)) _a.call(lines_1);
                    }
                    finally { if (e_1) throw e_1.error; }
                    return [7 /*endfinally*/];
                case 10:
                    totalLines += items.length;
                    if (options.limit && totalLines >= options.limit)
                        return [3 /*break*/, 12];
                    _b.label = 11;
                case 11:
                    if (!lastPage) return [3 /*break*/, 1];
                    _b.label = 12;
                case 12: return [2 /*return*/];
            }
        });
    });
}
exports.default = generateContent;
