import { __assign, __awaiter, __generator, __read } from "tslib";
import Button from '@vlsergey/react-bootstrap-button-with-spinner';
import React, { useCallback, useState } from 'react';
import Alert from 'react-bootstrap/Alert';
import Col from 'react-bootstrap/Col';
import Modal from 'react-bootstrap/Modal';
import ProgressBar from 'react-bootstrap/ProgressBar';
import Row from 'react-bootstrap/Row';
import DefaultUserOptions from './DefaultUserOptions';
import generateCsv from './generateCsv';
import UserOptionsFormPart from './UserOptionsFormPart';
function ExportToCsvModal(_a) {
    var _this = this;
    var fileName = _a.fileName, fields = _a.fields, fetchPage = _a.fetchPage, _b = _a.idPrefix, idPrefix = _b === void 0 ? 'csvExport' : _b, _c = _a.modalHeader, modalHeader = _c === void 0 ? 'Export to CSV' : _c, onHide = _a.onHide, show = _a.show;
    var _d = __read(useState(DefaultUserOptions), 2), userOptions = _d[0], setUserOptions = _d[1];
    var _e = __read(useState(false), 2), retry = _e[0], setRetry = _e[1];
    var _f = __read(useState(null), 2), error = _f[0], setError = _f[1];
    var _g = __read(useState(false), 2), inProgress = _g[0], setInProgress = _g[1];
    var _h = __read(useState(0), 2), progress = _h[0], setProgress = _h[1];
    var _j = __read(useState(100), 2), progressMax = _j[0], setProgressMax = _j[1];
    var doGenerate = useCallback(function () { return __awaiter(_this, void 0, void 0, function () {
        var err_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    setError(null);
                    setInProgress(true);
                    setProgress(0);
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, 4, 5]);
                    return [4 /*yield*/, generateCsv(__assign(__assign({}, userOptions), { fileName: fileName, fields: fields, fetchPage: fetchPage }), function (progress, progressMax) {
                            setProgress(progress);
                            setProgressMax(progressMax);
                        })];
                case 2:
                    _a.sent();
                    return [3 /*break*/, 5];
                case 3:
                    err_1 = _a.sent();
                    console.warn('Unable to export to CSV: ');
                    console.warn(err_1);
                    setError(err_1);
                    return [3 /*break*/, 5];
                case 4:
                    setInProgress(false);
                    setRetry(true);
                    return [7 /*endfinally*/];
                case 5: return [2 /*return*/];
            }
        });
    }); }, [fetchPage, fields, fileName, setProgress, setProgressMax, userOptions]);
    return React.createElement(Modal, { onHide: onHide, show: show },
        React.createElement(Modal.Header, { closeButton: true }, modalHeader),
        React.createElement(Modal.Body, null,
            React.createElement(Row, null,
                React.createElement(Col, null,
                    React.createElement(UserOptionsFormPart, { disabled: inProgress, idPrefix: idPrefix + 'Options', onChange: setUserOptions, value: userOptions }))),
            error && React.createElement(Row, null,
                React.createElement(Col, null,
                    React.createElement(Alert, { variant: "danger" },
                        'Error occured on CSV export: ',
                        error.message || JSON.stringify(error)))),
            !inProgress && !error && progress == progressMax && React.createElement(Row, null,
                React.createElement(Col, null,
                    React.createElement(Alert, { variant: "info" }, 'CSV export completed'))),
            React.createElement(Row, null,
                React.createElement(Col, null,
                    React.createElement("div", { style: { marginBottom: 12 } },
                        React.createElement(ProgressBar, { animated: inProgress, max: progressMax, now: progress }))))),
        React.createElement(Modal.Footer, null,
            React.createElement(Button, { disabled: inProgress, onClick: doGenerate, variant: "primary" }, retry ? 'Retry export to CSV' : 'Export to CSV'),
            React.createElement(Button, { onClick: onHide, variant: "secondary" }, "Close")));
}
export default React.memo(ExportToCsvModal);
