import { __assign } from "tslib";
import React, { useCallback } from 'react';
import Form from 'react-bootstrap/Form';
var html_value_to_value = {
    n: '\n',
    r: '\r',
    rn: '\r\n',
    t: '\t',
};
var value_to_html_value = {
    '\n': 'n',
    '\r': 'r',
    '\r\n': 'rn',
    '\t': 't',
};
function UserOptionsFormPart(_a) {
    var _b = _a.disabled, disabled = _b === void 0 ? false : _b, _c = _a.idPrefix, idPrefix = _c === void 0 ? '' : _c, onChange = _a.onChange, value = _a.value;
    var handleChange = useCallback(function (_a) {
        var _b;
        var currentTarget = _a.currentTarget;
        onChange(__assign(__assign({}, value), (_b = {}, _b[currentTarget.name] = html_value_to_value[currentTarget.value] || currentTarget.value, _b)));
    }, [onChange, value]);
    var handleTrigger = useCallback(function (_a) {
        var _b;
        var _c = _a.currentTarget, name = _c.name, checked = _c.checked;
        var fieldName = name;
        onChange(__assign(__assign({}, value), (_b = {}, _b[fieldName] = checked, _b)));
    }, [onChange, value]);
    return React.createElement(React.Fragment, null,
        React.createElement(Form.Group, null,
            React.createElement(Form.Check, { checked: value.header, disabled: disabled, id: idPrefix + "header", label: "Include header line (with column names) to CSV", name: "header", onChange: handleTrigger })),
        React.createElement(Form.Group, null,
            React.createElement(Form.Label, null, "Values separator"),
            React.createElement(Form.Control, { as: "select", disabled: disabled, id: idPrefix + "separator", name: "separator", onChange: handleChange, value: value_to_html_value[value.separator] || value.separator },
                React.createElement("option", { value: "," }, "Colon \u201C,\u201D"),
                React.createElement("option", { value: "t" }, "Tab \u201C\\t\u201D"),
                React.createElement("option", { value: ";" }, "Semicolon \u201C;\u201D"))),
        React.createElement(Form.Group, null,
            React.createElement(Form.Label, null, "Line break character"),
            React.createElement(Form.Control, { as: "select", disabled: disabled, id: idPrefix + "newline", name: "newline", onChange: handleChange, value: value_to_html_value[value.newline] || value.newline },
                React.createElement("option", { value: 'rn' }, "Windows-style \u201C\\r\\n\u201D"),
                React.createElement("option", { value: 'n' }, "*nix-style \u201C\\n\u201D"),
                React.createElement("option", { value: 'r' }, "Mac-style \u201C\\r\u201D"))));
}
export default React.memo(UserOptionsFormPart);
