import { __awaiter, __generator } from "tslib";
import streamsaver from 'streamsaver';
import generateCsvBody from './generateCsvBody';
import generateCsvHeader from './generateCsvHeader';
export default function generateCsv(options, onProgress) {
    return __awaiter(this, void 0, void 0, function () {
        var encode, progressMax, fileName, csvStream, csvWriter, header, done_1;
        var _this = this;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    onProgress(0, 100);
                    encode = TextEncoder.prototype.encode.bind(new TextEncoder());
                    progressMax = 104;
                    onProgress(1, progressMax);
                    fileName = options.fileName;
                    csvStream = streamsaver.createWriteStream(fileName);
                    csvWriter = csvStream.getWriter();
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, , 6, 8]);
                    // UTF-8 BOM (byte order mark)
                    return [4 /*yield*/, csvWriter.write(Uint8Array.of(0xEF, 0xBB, 0xBF))];
                case 2:
                    // UTF-8 BOM (byte order mark)
                    _a.sent();
                    if (!options.header) return [3 /*break*/, 4];
                    header = generateCsvHeader(options);
                    return [4 /*yield*/, csvWriter.write(encode(header))];
                case 3:
                    _a.sent();
                    _a.label = 4;
                case 4:
                    onProgress(2, progressMax);
                    done_1 = 0;
                    return [4 /*yield*/, generateCsvBody(options, function (totalElements, line) { return __awaiter(_this, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0: return [4 /*yield*/, csvWriter.write(encode(line))];
                                    case 1:
                                        _a.sent();
                                        onProgress(3 + done_1++, 4 + totalElements);
                                        return [2 /*return*/];
                                }
                            });
                        }); })];
                case 5:
                    _a.sent();
                    return [3 /*break*/, 8];
                case 6: return [4 /*yield*/, csvWriter.close()];
                case 7:
                    _a.sent();
                    return [7 /*endfinally*/];
                case 8:
                    onProgress(progressMax, progressMax);
                    return [2 /*return*/];
            }
        });
    });
}
